/***
 * Condition variable test #3
 *
 * Change Log:
 * 03/10/22 ghort	created
 * 03/11/03 ghort	cleaned up and integrated
 * 04/10/25 pallas	updated for new assignment specification
 * 05/01/13 pallas	updated for user space API
 */

static char *	desc =
	"Condition variable test #3\n"
	"Tests whether the timeout version of condition variables\n"
	"really does not block.\n\n";


#include "prereq/assignment-3.h"
#include "defs.h"


/*
 * Length of wait timeout on condition variable.
 */
#define CV_TIMEOUT_MS	2000


int
main (void)
{
	struct mutex	mtx;
	struct cond	cond;

	printf (desc);

	// init
	mutex_init (& mtx);
	cond_init (& cond);


	/*
	 * Test the timeouts.
	 */
	mutex_lock (& mtx);

	printf ("Wait on condition variable for (approx.) 2 seconds...\n");
	cond_wait_timeout (& cond, & mtx, CV_TIMEOUT_MS * 1000);

	printf ("Wait on condition variable for (approx.) 4 seconds...\n");
	cond_wait_timeout (& cond, & mtx, 2 * CV_TIMEOUT_MS * 1000);


	// clean up
	cond_destroy (& cond);
	mutex_destroy (& mtx);

	// print the result
	printf ("Test passed...\n");
	return 0;
} /* main */

