/***
 * Input/output test #1
 *
 * Change Log:
 * 03/10/22 ghort	created
 * 03/11/03 ghort	cleaned up and integrated
 * 03/11/04 pallas	further cleanups
 * 03/11/07 pallas	modified to pass shorter buffer to getc
 * 04/10/25 pallas	updated for new assignment specification
 * 05/01/11 pallas	updated for user space API
 */

static char *	desc =
	"Input/output test #1\n"
	"Tests basic input output functions (printf, getchar, "
	"and gets).\n\n";


#include "prereq/assignment-3.h"
#include "defs.h"


#define	BUFFER_LENGTH	128
#define POLL_DELAY_MS	1000


int
main (void)
{
	int 	key;
	int 	len;
	char	buf [BUFFER_LENGTH];

	printf (desc);

	/*
	 * Test blocking getc ().
	 */
	printf ("Testing getchar (), write something (<enter> to finish):\n");
	do {
		key = getchar ();
		if (key != '\n')
			printf ("<'%c', %d> ", key, key);
	} while (key != '\n');
	printf ("\n");

	/*
	 * Test blocking gets ().
	 */
	printf ("Testing gets (), write something (<enter> to finish):\n");
	len = gets (buf, sizeof (buf));
	if (buf [len - 1] == '\n')
		buf [len - 1] = '\0';

	printf ("You have written: '%s'\n", buf);


	// this statement must be reached
	printf ("Test passed ...\n");
	return 0;
} /* main */
