/***
 * Semaphore test #3
 *
 * Change Log:
 * 03/10/22 ghort	created
 * 04/10/25 pallas	updated for new assignment specification
 * 05/01/13 pallas	updated for user space API
 */

static char *	desc =
	"Semaphore test #3\n"
	"Tests whether the timeout version of semaphores really\n"
	"does not block.\n\n";


#include "prereq/assignment-3.h"
#include "defs.h"


/*
 * Length of down timeout on semaphore.
 */
#define SEM_TIMEOUT_MS	2000


int
main (void)
{
	int 			success;
	int			result;
	struct semaphore	sem;

	printf (desc);

	// init
	success = 1;
	sem_init (& sem, 0);


	/*
	 * Test the timeouts.
	 */
	printf ("Try down on semaphore for (approx.) 2 seconds...\n");
	result = sem_down_timeout (& sem, SEM_TIMEOUT_MS * 1000);
	success = (result == ETIMEDOUT) ? success : 0;

	printf ("Try down on semaphore for (approx.) 4 seconds...\n");
	result = sem_down_timeout (& sem, 2 * SEM_TIMEOUT_MS * 1000);
	success = (result == ETIMEDOUT) ? success : 0;


	// clean up
	sem_destroy (& sem);

	// print the result
	if (success) {
		printf ("Test passed...\n");
	} else {
		printf ("Some of the operations did not return ETIMEDOUT.\n"
			"Test failed.\n");
	}

	return 0;
}
